## piglit 0~git20200212

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules")

INCLUDE (GNUInstallDirs)
INCLUDE (CheckCCompilerFlag)
INCLUDE (CheckCSourceCompiles)
INCLUDE (CheckCXXCompilerFlag)
INCLUDE (CheckFunctionExists)
INCLUDE (CheckIncludeFile)
INCLUDE (FindPkgConfig)

# http://www.cmake.org/cmake/help/v3.0/policy/CMP0042.html
if (POLICY CMP0042)
	cmake_policy (SET CMP0042 NEW)
endif()

if (POLICY CMP0072)
        cmake_policy (SET CMP0072 OLD)
endif()

project (piglit)

# Require MinGW
if (MSVC)
	message (FATAL_ERROR "Windows builds require MinGW")
endif ()

find_package(Threads)
find_package(PNG)
if(PNG_FOUND)
	add_definitions(-DPIGLIT_HAS_PNG)
endif(PNG_FOUND)
find_package(X11)
if(X11_FOUND)
	set(PIGLIT_HAS_X11 True)
	add_definitions(-DPIGLIT_HAS_X11)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
	set(PIGLIT_BUILD_GLES_TESTS_DEFAULT ON)
else()
	set(PIGLIT_BUILD_GLES_TESTS_DEFAULT OFF)
endif()

option(PIGLIT_BUILD_GL_TESTS "Build tests for OpenGL" ON)
option(PIGLIT_BUILD_GLES1_TESTS "Build tests for OpenGL ES1" ${PIGLIT_BUILD_GLES_TESTS_DEFAULT})
option(PIGLIT_BUILD_GLES2_TESTS "Build tests for OpenGL ES2" ${PIGLIT_BUILD_GLES_TESTS_DEFAULT})
option(PIGLIT_BUILD_GLES3_TESTS "Build tests for OpenGL ES3" ${PIGLIT_BUILD_GLES_TESTS_DEFAULT})
option(PIGLIT_BUILD_CL_TESTS "Build tests for OpenCL" OFF)

if(PIGLIT_BUILD_GL_TESTS)
	find_package(OpenGL REQUIRED)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	option(PIGLIT_USE_WAFFLE "Use Waffle in place of GLUT" ON)
else()
	option(PIGLIT_USE_WAFFLE "Use Waffle in place of GLUT" OFF)
endif()

if(PIGLIT_USE_WAFFLE)
	if (NOT WIN32)
		pkg_check_modules(Waffle REQUIRED waffle-1)

		if(NOT Waffle_FOUND)
			message(FATAL_ERROR "Failed to find Waffle. If Waffle "
			"is not packaged for your distribution, you can get "
			"it at http://www.waffle-gl.org."
		)
		endif()

		# Check the installed waffle version.
		#
		# We cannot reliably check the version with pkg_check_modules(), but
		# instead must check the version manually as below. The problem is that,
		# if one passes a required version to pkg_check_modules(), CMake
		# validates the required version at most once for the lifetime of the
		# source tree.  If someone changes the required version by editing the
		# CMakeLists, CMake fails to detect the new requirement.
		set(Waffle_REQUIRED_VERSION "1.5.0")
		if(Waffle_VERSION VERSION_LESS Waffle_REQUIRED_VERSION)
			message(FATAL_ERROR "Found waffle-${Waffle_VERSION}, but "
			"piglit requires waffle-${Waffle_REQUIRED_VERSION}")
		endif()
	else ()
		find_path(Waffle_INCLUDE_DIRS waffle.h)
		find_library(Waffle_LDFLAGS waffle-1)
		if(Waffle_INCLUDE_DIRS AND Waffle_LDFLAGS)
			set(Waffle_FOUND TRUE)
		else()
			message(FATAL_ERROR "Failed to find Waffle. Get and build Waffle from "
				"http://www.waffle-gl.org and set Waffle_INCLUDE_DIRS and "
				"Waffle_LDFLAGS variables accordingly."
			)
		endif()
	endif ()

	add_definitions(-DPIGLIT_USE_WAFFLE)
	add_definitions(-DWAFFLE_API_VERSION=0x0103)
else()
	find_package(GLUT REQUIRED)

	# The 'REQUIRED' above correctly produces an error for
	# OpenGL, but there's a bug involving FindGLUT.cmake
	# that fails to produce the error as of CMake 2.8.5.
	#
	# Instead, CMake keeps going and eventually spams
	# the console with a message for every target that used
	# e.g. the ${GLUT_INCLUDE_DIR} variable. So it
	# prints a line for basically every single test in piglit.
	#
	# Work around the bug and error out quickly here instead.
	if (NOT GLUT_FOUND)
		message(FATAL_ERROR "GLUT library not found")
	endif()
endif(PIGLIT_USE_WAFFLE)

if(PIGLIT_BUILD_GLES1_TESTS AND NOT PIGLIT_USE_WAFFLE)
	message(FATAL_ERROR "Option PIGLIT_BUILD_GLES1_TESTS requires PIGLIT_USE_WAFFLE")
endif(PIGLIT_BUILD_GLES1_TESTS AND NOT PIGLIT_USE_WAFFLE)

if(PIGLIT_BUILD_GLES2_TESTS AND NOT PIGLIT_USE_WAFFLE)
	message(FATAL_ERROR "Option PIGLIT_BUILD_GLES2_TESTS requires PIGLIT_USE_WAFFLE")
endif(PIGLIT_BUILD_GLES2_TESTS AND NOT PIGLIT_USE_WAFFLE)

if(PIGLIT_BUILD_GLES3_TESTS AND NOT PIGLIT_USE_WAFFLE)
	message(FATAL_ERROR "Option PIGLIT_BUILD_GLES3_TESTS requires PIGLIT_USE_WAFFLE")
endif(PIGLIT_BUILD_GLES3_TESTS AND NOT PIGLIT_USE_WAFFLE)

if(PIGLIT_BUILD_CL_TESTS)
	find_package(OpenCL REQUIRED)
endif(PIGLIT_BUILD_CL_TESTS)

IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	if(X11_FOUND AND OPENGL_gl_LIBRARY)
		# Assume the system has GLX. In the future, systems may exist
		# with libGL and libX11 but no GLX, but that world hasn't
		# arrived yet.
		set(PIGLIT_HAS_GLX True)
		add_definitions(-DPIGLIT_HAS_GLX)
	endif()

	pkg_check_modules(GBM QUIET gbm>=17.1)
	if(GBM_FOUND)
		set(PIGLIT_HAS_GBM True)
		add_definitions(-DPIGLIT_HAS_GBM)
		set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${GBM_LIBRARIES})
		CHECK_FUNCTION_EXISTS(gbm_bo_map PIGLIT_HAS_GBM_BO_MAP)
		if (PIGLIT_HAS_GBM_BO_MAP)
			add_definitions(-DPIGLIT_HAS_GBM_BO_MAP)
		endif()
	endif(GBM_FOUND)

	pkg_check_modules(WAYLAND QUIET wayland-client)
	if (WAYLAND_FOUND)
		set(PIGLIT_HAS_WAYLAND True)
		add_definitions(-DPIGLIT_HAS_WAYLAND)

		FIND_LIBRARY(HAVE_XKBCOMMON NAMES xkbcommon)
		if(NOT HAVE_XKBCOMMON)
			message(FATAL_ERROR "Wayland support requires xkbcommon. "
				"Failed to find xkbcommon library.")
		endif()
		pkg_check_modules(XKBCOMMON QUIET xkbcommon)
	endif()

	pkg_check_modules(LIBDRM QUIET libdrm)
	pkg_check_modules(LIBDRM_INTEL QUIET libdrm_intel)
	pkg_check_modules(XCB QUIET xcb)
	pkg_check_modules(XCB_DRI2 QUIET xcb-dri2)
	pkg_check_modules(GLPROTO QUIET glproto)
ELSEIF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
	if (PIGLIT_USE_WAFFLE)
		set(PIGLIT_HAS_WGL True)
		add_definitions(-DPIGLIT_HAS_WGL)
	endif()
ENDIF()

IF(PIGLIT_HAS_GLX)
	option(PIGLIT_BUILD_GLX_TESTS "Build tests that require GLX" ON)
ELSE()
	option(PIGLIT_BUILD_GLX_TESTS "Build tests that require GLX" OFF)
ENDIF()

IF(PIGLIT_HAS_WGL)
	option(PIGLIT_BUILD_WGL_TESTS "Build tests that require WGL" ON)
ELSE()
	option(PIGLIT_BUILD_WGL_TESTS "Build tests that require WGL" OFF)
ENDIF()


# Choose to build tests that use dma_buf.
#
# Piglit's dma_buf utilities require xcb-dri2 to gain DRM authentication.
#
# The presence of libdrm is not sufficient. At least one libdrm_${hardware}
# library is also needed.
#
# When building for Intel, libdrm_intel>=2.4.38 is required because support for
# drm-prime arrived in that version.
#
if(LIBDRM_FOUND AND XCB_DRI2_FOUND AND
   ((LIBDRM_INTEL_VERSION VERSION_GREATER "2.4.37") OR
     PIGLIT_HAS_GBM_BO_MAP))
	set(PIGLIT_BUILD_DMA_BUF_TESTS_IS_VALID true)
else()
	set(PIGLIT_BUILD_DMA_BUF_TESTS_IS_VALID false)
endif()

if(PIGLIT_BUILD_DMA_BUF_TESTS_IS_VALID)
	option(PIGLIT_BUILD_DMA_BUF_TESTS "Build tests that use dma_buf" ON)
else()
	option(PIGLIT_BUILD_DMA_BUF_TESTS "Build tests that use dma_buf" OFF)
endif()

# If the users has updated PIGLIT_BUILD_DMA_BUF_TESTS in the CMakeCache, then
# we need to validate it.
if(PIGLIT_BUILD_DMA_BUF_TESTS AND NOT PIGLIT_BUILD_DMA_BUF_TESTS_IS_VALID)
	message(FATAL_ERROR
		"PIGLIT_BUILD_DMA_BUF_TESTS require libdrm, "
		"libdrm_intel>=2.4.38, and xcb-dri2")
endif()

IF(PIGLIT_BUILD_GLX_TESTS)
	pkg_check_modules(GLPROTO REQUIRED glproto)
ENDIF()

set(Python_ADDITIONAL_VERSIONS
    3.8 3.7 3.6 3.5 2.7)
find_package(PythonInterp REQUIRED)
find_package(PythonSix 1.5.2 REQUIRED)
find_package(PythonNumpy 1.7.0 REQUIRED)

# CMake doesn't have a VERSION_GREATER_EQUAL function, at least as of 3.0,
# And mako 1.0.2 contains bug fixes required for python 3.5 to work, so
# the only solution (short of having a series of "OR" statements, is this)
if (PYTHON_VERSION_STRING VERSION_GREATER 3.4.999999)
	find_package(PythonMako 1.0.2 REQUIRED)
else ()
	find_package(PythonMako 0.8.0 REQUIRED)
endif (PYTHON_VERSION_STRING VERSION_GREATER 3.4.999999)

find_package(bash-completion NO_MODULE)

# Default to compiling with debug information (`gcc -g`):
if(NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE Debug CACHE STRING
	"May be one of: None Debug RelWithDebInfo Release MinSizeRel" FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if (NOT MSVC)
	CHECK_C_COMPILER_FLAG("-Wall" C_COMPILER_FLAG_WALL)
	IF (C_COMPILER_FLAG_WALL)
		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
	ENDIF (C_COMPILER_FLAG_WALL)
	CHECK_CXX_COMPILER_FLAG("-Wall" CXX_COMPILER_FLAG_WALL)
	IF (CXX_COMPILER_FLAG_WALL)
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
	ENDIF (CXX_COMPILER_FLAG_WALL)

	# Target C99.  GCC's default is gnu11 for 5.0 and newer, gnu89 for
	# older versions.
	check_c_compiler_flag ("-std=gnu99" C_COMPILER_FLAG_STD_GNU99)
	if (C_COMPILER_FLAG_STD_GNU99)
		set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
	endif ()
	# MSVC does not support C99 variable length arrays
	CHECK_C_COMPILER_FLAG("-Werror=vla" C_COMPILER_FLAG_WEVLA)
	IF (C_COMPILER_FLAG_WEVLA)
		SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=vla")
	ENDIF ()
	# GCC allows void pointer arithmetic, but it is not part of ISO C and
	# in particular MSVC will throw `C2036: 'void *' : unknown size`
	check_c_compiler_flag ("-Werror=pointer-arith" C_COMPILER_FLAG_WEPOINTER_ARITH)
	if (C_COMPILER_FLAG_WEPOINTER_ARITH)
		set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=pointer-arith")
	endif ()
	# MSVC only supports C99 variadic macros.  It doesn't support the
	# non-standard GNU named variadic macro syntax that's documented in
	# https://gcc.gnu.org/onlinedocs/cpp/Variadic-Macros.html
	#
	# XXX: on older GCC version this option has no effect unless -Wpedantic
	# is set, but this should be fixed on future GCC versions, per
	# https://gcc.gnu.org/ml/gcc-patches/2014-04/msg01459.html
	check_c_compiler_flag ("-Werror=variadic-macros" C_COMPILER_FLAG_WVARIADIC_MACROS)
	if (C_COMPILER_FLAG_WVARIADIC_MACROS)
		set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=variadic-macros")
	endif ()

	CHECK_CXX_COMPILER_FLAG("-Wno-narrowing" CXX_COMPILER_FLAG_WNO_NARROWING)
	IF (CXX_COMPILER_FLAG_WNO_NARROWING)
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-narrowing")
	ENDIF (CXX_COMPILER_FLAG_WNO_NARROWING)
else ()
	# Adjust warnings
	add_definitions (-W3)
	add_definitions (-wd4018) # signed/unsigned mismatch
	add_definitions (-wd4244) # conversion from 'type1' to 'type2', possible loss of data
	add_definitions (-wd4305) # truncation from 'type1' to 'type2'
	add_definitions (-wd4800) # forcing value to bool 'true' or 'false' (performance warning)

	add_definitions (-D_CRT_SECURE_NO_DEPRECATE -D_CRT_SECURE_NO_WARNINGS -D_CRT_NONSTDC_NO_WARNINGS)
	add_definitions (-D_SCL_SECURE_NO_DEPRECATE -D_SCL_SECURE_NO_WARNINGS)
endif ()

if (MINGW)
	# Match MSVC default stack size
	set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--stack,1048576")

	# Avoid depending on MinGW runtime DLLs
	check_cxx_compiler_flag (-static-libgcc HAVE_STATIC_LIBGCC_FLAG)
	if (HAVE_STATIC_LIBGCC_FLAG)
		set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static-libgcc")
		set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -static-libgcc")
		set (CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -static-libgcc")
	endif ()
	check_cxx_compiler_flag (-static-libstdc++ HAVE_STATIC_LIBSTDCXX_FLAG)
	if (HAVE_STATIC_LIBSTDCXX_FLAG)
		set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static-libstdc++")
		set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -static-libstdc++")
		set (CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -static-libstdc++")
	endif ()
endif ()

if (${CMAKE_C_COMPILER_ID} STREQUAL "SunPro")
	# Use C++ to link C files.
	# http://developers.sun.com/solaris/articles/mixing.html#linking
	# Modified rule from Modules/CMakeCInformation.cmake.
	set (CMAKE_C_LINK_EXECUTABLE
		"<CMAKE_CXX_COMPILER> <FLAGS> <CMAKE_C_LINK_FLAGS> <LINK_FLAGS> <OBJECTS> -o <TARGET> <LINK_LIBRARIES>")
endif()

# Always enable GNU C extensions.  Non-GNU platforms will need to
# define wrappers for them.
add_definitions(-D_GNU_SOURCE)

if (WIN32)
	# MSVC & MinGW only define & use APIENTRY
	add_definitions (-DGLAPIENTRY=__stdcall)

	# Avoid namespace pollution when including windows.h

=== asmparsertest/CMakeLists.txt ===
piglit_include_target_api()

=== spec/CMakeLists.txt ===
add_subdirectory (amd_compressed_atc_texture)
add_subdirectory (amd_framebuffer_multisample_advanced)
add_subdirectory (amd_depth_clamp_separate)
add_subdirectory (amd_performance_monitor)
add_subdirectory (amd_pinned_memory)
add_subdirectory (arb_arrays_of_arrays)
add_subdirectory (arb_base_instance)
add_subdirectory (arb_bindless_texture)
add_subdirectory (arb_buffer_storage)
add_subdirectory (arb_clear_buffer_object)
add_subdirectory (arb_clear_texture)
add_subdirectory (arb_clip_control)
add_subdirectory (arb_color_buffer_float)
add_subdirectory (arb_copy_image)
add_subdirectory (arb_compute_shader)
add_subdirectory (arb_compute_variable_group_size)
add_subdirectory (arb_cull_distance)
add_subdirectory (arb_debug_output)
add_subdirectory (khr_debug)
add_subdirectory (khr_texture_compression_astc)
add_subdirectory (oes_texture_compression_astc)
add_subdirectory (arb_depth_clamp)
add_subdirectory (arb_draw_indirect)
add_subdirectory (arb_draw_instanced)
add_subdirectory (arb_es2_compatibility)
add_subdirectory (arb_es3_compatibility)
add_subdirectory (arb_enhanced_layouts)
add_subdirectory (arb_explicit_attrib_location)
add_subdirectory (arb_explicit_uniform_location)
add_subdirectory (arb_framebuffer_no_attachments)
add_subdirectory (arb_framebuffer_object)
add_subdirectory (arb_framebuffer_srgb)
add_subdirectory (arb_geometry_shader4)
add_subdirectory (arb_get_program_binary)
add_subdirectory (arb_get_texture_sub_image)
add_subdirectory (arb_gpu_shader5)
add_subdirectory (arb_gpu_shader_fp64)
add_subdirectory (arb_instanced_arrays)
add_subdirectory (arb_internalformat_query)
add_subdirectory (arb_internalformat_query2)
add_subdirectory (arb_invalidate_subdata)
add_subdirectory (arb_map_buffer_alignment)
add_subdirectory (arb_map_buffer_range)
add_subdirectory (arb_multisample)
add_subdirectory (arb_occlusion_query)
add_subdirectory (arb_occlusion_query2)
add_subdirectory (arb_point_parameters)
add_subdirectory (arb_point_sprite)
add_subdirectory (arb_provoking_vertex)
add_subdirectory (arb_robustness)
add_subdirectory (arb_sample_locations)
add_subdirectory (arb_sample_shading)
add_subdirectory (arb_sampler_objects)
add_subdirectory (arb_seamless_cube_map)
add_subdirectory (amd_seamless_cubemap_per_texture)
add_subdirectory (amd_vertex_shader_layer)
add_subdirectory (amd_vertex_shader_viewport_index)
add_subdirectory (arb_separate_shader_objects)
add_subdirectory (arb_shader_subroutine)
add_subdirectory (arb_shader_texture_lod/execution)
add_subdirectory (arb_shader_atomic_counters)
add_subdirectory (arb_shader_objects)
add_subdirectory (arb_shader_image_load_store)
add_subdirectory (arb_shader_image_size)
add_subdirectory (arb_shading_language_420pack/execution)
add_subdirectory (arb_shading_language_include)
add_subdirectory (arb_stencil_texturing)
add_subdirectory (arb_sync)
add_subdirectory (arb_uniform_buffer_object)
add_subdirectory (ati_draw_buffers)
add_subdirectory (arb_sparse_buffer)
add_subdirectory (arb_tessellation_shader)
add_subdirectory (arb_texture_buffer_object)
add_subdirectory (arb_texture_buffer_range)
add_subdirectory (arb_texture_compression)
add_subdirectory (arb_texture_cube_map)
add_subdirectory (arb_texture_cube_map_array)
add_subdirectory (arb_texture_float)
add_subdirectory (arb_texture_rectangle)
add_subdirectory (arb_texture_multisample)
add_subdirectory (arb_texture_storage)
add_subdirectory (arb_texture_storage_multisample)
add_subdirectory (arb_texture_view)
add_subdirectory (arb_timer_query)
add_subdirectory (arb_transform_feedback2)
add_subdirectory (arb_transform_feedback3)
add_subdirectory (arb_transform_feedback_overflow_query)
add_subdirectory (arb_viewport_array)
add_subdirectory (ati_envmap_bumpmap)
add_subdirectory (ati_fragment_shader)
add_subdirectory (ext_depth_bounds_test)
add_subdirectory (ext_frag_depth)
add_subdirectory (ext_fog_coord)
add_subdirectory (ext_framebuffer_multisample)
add_subdirectory (ext_framebuffer_multisample_blit_scaled)
add_subdirectory (ext_framebuffer_object)
add_subdirectory (ext_memory_object)
add_subdirectory (ext_memory_object_fd)
add_subdirectory (ext_packed_depth_stencil)
add_subdirectory (ext_packed_float)
add_subdirectory (ext_semaphore)
add_subdirectory (ext_semaphore_fd)
add_subdirectory (ext_shader_image_load_store)
add_subdirectory (ext_shader_samples_identical)
add_subdirectory (ext_texture_env_combine)
add_subdirectory (ext_texture_swizzle)
add_subdirectory (ext_timer_query)
add_subdirectory (ext_transform_feedback)
add_subdirectory (nv_conditional_render)
add_subdirectory (nv_fill_rectangle)
add_subdirectory (nv_fog_distance)
add_subdirectory (nv_image_formats)
add_subdirectory (nv_texture_barrier)
add_subdirectory (nv_texture_env_combine4)
add_subdirectory (oes_compressed_etc1_rgb8_texture)
add_subdirectory (oes_compressed_paletted_texture)
add_subdirectory (oes_required_internalformat)
add_subdirectory (oes_matrix_get)
add_subdirectory (arb_draw_elements_base_vertex)
add_subdirectory (arb_fragment_program)
add_subdirectory (arb_vertex_array_bgra)
add_subdirectory (arb_vertex_buffer_object)
add_subdirectory (arb_vertex_program)
add_subdirectory (arb_copy_buffer)
add_subdirectory (arb_shader_storage_buffer_object)
add_subdirectory (glsl-1.10)
add_subdirectory (glsl-1.20)
add_subdirectory (glsl-1.30)
add_subdirectory (glsl-1.40)
add_subdirectory (glsl-1.50)
add_subdirectory (glsl-es-1.00)
add_subdirectory (glsl-es-3.00)
add_subdirectory (gl-1.0)
add_subdirectory (gl-1.1)
add_subdirectory (gl-1.2)
add_subdirectory (gl-1.3)
add_subdirectory (gl-1.4)
add_subdirectory (gl-1.5)
add_subdirectory (gl-2.0)
add_subdirectory (gl-2.1)
add_subdirectory (gl-3.0)
add_subdirectory (gl-3.1)
add_subdirectory (gl-3.2)
add_subdirectory (gl-3.3)
add_subdirectory (gl-4.3)
add_subdirectory (gl-4.4)
add_subdirectory (gl-4.5)
add_subdirectory (gles-2.0)
add_subdirectory (gles-3.0)
add_subdirectory (glx_arb_create_context)
add_subdirectory (glx_ext_import_context)
add_subdirectory (glx_mesa_query_renderer)
add_subdirectory (glx_oml_sync_control)
add_subdirectory (arb_vertex_type_10f_11f_11f_rev)
add_subdirectory (arb_vertex_type_2_10_10_10_rev)
add_subdirectory (ext_texture_array)
add_subdirectory (ext_texture_integer)
add_subdirectory (arb_draw_buffers)
add_subdirectory (arb_draw_buffers_blend)
add_subdirectory (oes_draw_texture)
add_subdirectory (oes_fixed_point)
add_subdirectory (ext_image_dma_buf_import)
add_subdirectory (arb_program_interface_query)
add_subdirectory (arb_blend_func_extended)
add_subdirectory (ext_unpack_subimage)
add_subdirectory (arb_vertex_array_object)
add_subdirectory (oes_texture_float)
add_subdirectory (arb_direct_state_access)
add_subdirectory (ext_polygon_offset_clamp)
add_subdirectory (arb_pipeline_statistics_query)
add_subdirectory (arb_texture_stencil8)
add_subdirectory (arb_vertex_attrib_64bit)
add_subdirectory (ext_framebuffer_blit)
add_subdirectory (mesa_pack_invert)
add_subdirectory (ext_texture_format_bgra8888)
add_subdirectory (oes_draw_elements_base_vertex)
add_subdirectory (arb_shader_draw_parameters)
add_subdirectory (arb_indirect_parameters)
add_subdirectory (arb_query_buffer_object)
add_subdirectory (ext_window_rectangles)
add_subdirectory (arb_shader_texture_image_samples)
add_subdirectory (arb_texture_barrier)
add_subdirectory (intel_conservative_rasterization)
add_subdirectory (arb_post_depth_coverage)
add_subdirectory (arb_fragment_shader_interlock)
add_subdirectory (ext_occlusion_query_boolean)
add_subdirectory (ext_disjoint_timer_query)
add_subdirectory (intel_blackhole_render)
add_subdirectory (ext_texture_norm16)
add_subdirectory (ext_render_snorm)
add_subdirectory (ext_texture_compression_bptc)
add_subdirectory (ext_texture_compression_rgtc)
add_subdirectory (ext_color_buffer_float)
add_subdirectory (khr_parallel_shader_compile)
add_subdirectory (ext_direct_state_access)
add_subdirectory (arb_gpu_shader_int64)
add_subdirectory (oes_egl_image_external_essl3)
add_subdirectory (intel_performance_query)

=== util/CMakeLists.txt ===
add_definitions(-DSOURCE_DIR="${piglit_SOURCE_DIR}/")

if(PIGLIT_HAS_POSIX_CLOCK_MONOTONIC AND HAVE_LIBRT)
    link_libraries(rt)
endif()

# CMake requires that source file properties be set in the same directory where
# the property is used.
set_source_files_properties(
	${piglit_dispatch_gen_outputs}
	PROPERTIES GENERATED 1
	)

link_libraries(${CMAKE_DL_LIBS})

if(HAVE_LIBCACA)
    link_libraries(caca)
endif()

if(HAVE_XKBCOMMON)
	link_libraries(${XKBCOMMON_LIBRARIES})
	include_directories(${XKBCOMMON_INCLUDE_DIRS})
endif()

if(PNG_FOUND)
	link_libraries(${PNG_LIBRARIES})
	include_directories(${PNG_INCLUDE_DIRS})
endif(PNG_FOUND)

set(UTIL_INCLUDES
	${CMAKE_CURRENT_BINARY_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}
	)

set(UTIL_SOURCES
	piglit-log.c
	piglit-util.c
	piglit-subprocess.c
	)

set(UTIL_GL_INCLUDES
	${UTIL_INCLUDES}
	${GLEXT_INCLUDE_DIR}
	${OPENGL_INCLUDE_PATH}
	${Waffle_INCLUDE_DIRS}
	)

set(UTIL_GL_SOURCES
	fdo-bitmap.c
	minmax-test.c
	piglit-dispatch.c
	piglit-dispatch-init.c
	piglit-fbo.cpp
	piglit-matrix.c
	piglit-test-pattern.cpp
	piglit-util-gl.c
	piglit-util-png.c
	piglit-vbo.cpp
	piglit-framework-gl.c
	piglit-framework-gl/piglit_gl_framework.c
	piglit-shader.c
	piglit-shader-test.c
	piglit_ktx.c
	rgb9e5.c
	r11g11b10f.c
	sized-internalformats.c
	${CMAKE_BINARY_DIR}/tests/util/piglit-util-gl-enum-gen.c
	)

set(UTIL_GL_LIBS
	piglitutil
	)

if(PIGLIT_USE_WAFFLE)
	list(APPEND UTIL_GL_SOURCES
		piglit-framework-gl/piglit_fbo_framework.c
		piglit-framework-gl/piglit_wfl_framework.c
		piglit-framework-gl/piglit_winsys_framework.c
		piglit-util-waffle.c
	)

	if(PIGLIT_HAS_WGL)
		list(APPEND UTIL_GL_SOURCES
			piglit-framework-gl/piglit_wgl_framework.c
		)
	endif()
	if(PIGLIT_HAS_GBM)
		list(APPEND UTIL_GL_SOURCES
			piglit-framework-gl/piglit_gbm_framework.c
		)
		list(APPEND UTIL_GL_LIBS
			${GBM_LDFLAGS}
		)
	endif()
	if(PIGLIT_HAS_WAYLAND)
		list(APPEND UTIL_GL_SOURCES
			piglit-framework-gl/piglit_wl_framework.c
		)
		list(APPEND UTIL_GL_INCLUDES
			${WAYLAND_wayland-client_INCLUDEDIR}
		)
	endif()
	if(PIGLIT_HAS_X11)
		list(APPEND UTIL_GL_SOURCES
			piglit-framework-gl/piglit_x11_framework.c
		)
	endif()

	list(APPEND UTIL_GL_LIBS
		${Waffle_LDFLAGS}
	)
	IF(PIGLIT_BUILD_GLX_TESTS)
		list(APPEND UTIL_GL_LIBS
			${OPENGL_gl_LIBRARY}
		)
	ENDIF(PIGLIT_BUILD_GLX_TESTS)
else()
	list(APPEND UTIL_GL_SOURCES
		piglit-framework-gl/piglit_glut_framework.c
	)

	list(APPEND UTIL_GL_LIBS
		${OPENGL_gl_LIBRARY}
	)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	# One needs to have at least one hardware driver present, otherwise
	# there is no point compiling just the dispatcher.
	if(PIGLIT_BUILD_DMA_BUF_TESTS)
		add_definitions(-DHAVE_LIBDRM)

		list(APPEND UTIL_GL_SOURCES
			piglit-framework-gl/piglit_drm_dma_buf.c
		)

		list(APPEND UTIL_GL_LIBS
			${LIBDRM_LDFLAGS}
			${XCB_LDFLAGS}
			${XCB_DRI2_LDFLAGS}
		)

		list(APPEND UTIL_GL_INCLUDES
			${LIBDRM_INCLUDE_DIRS}
			${XCB_INCLUDE_DIRS}
			${XCB_DRI2_INCLUDE_DIRS}
		)

		if(LIBDRM_INTEL_FOUND)
			add_definitions(-DHAVE_LIBDRM_INTEL)

			list(APPEND UTIL_GL_LIBS
				${LIBDRM_INTEL_LDFLAGS}
			)
		endif()
	endif()

	if(PIGLIT_HAS_X11)
		list(APPEND UTIL_GL_LIBS ${X11_X11_LIB})
	endif()

        if(PIGLIT_HAS_WAYLAND)
		list(APPEND UTIL_GL_LIBS ${WAYLAND_LDFLAGS})
        endif()

endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

piglit_include_target_api()

=== egl/spec/CMakeLists.txt ===
add_subdirectory (egl-1.4)
add_subdirectory (egl_ext_client_extensions)
add_subdirectory (egl_ext_device_base)
add_subdirectory (egl_ext_device_query)
add_subdirectory (egl_ext_device_enumeration)
add_subdirectory (egl_ext_device_drm)
add_subdirectory (egl_ext_platform_device)
add_subdirectory (egl_ext_image_dma_buf_import_modifiers)
add_subdirectory (egl_khr_create_context)
add_subdirectory (egl_khr_get_all_proc_addresses)
add_subdirectory (egl_khr_gl_image)
add_subdirectory (egl_khr_fence_sync)
add_subdirectory (egl_khr_surfaceless_context)
add_subdirectory (egl_mesa_device_software)
add_subdirectory (egl_mesa_platform_surfaceless)
add_subdirectory (egl_mesa_query_driver)

if (PIGLIT_HAS_X11)
	add_subdirectory (egl_chromium_sync_control)
endif (PIGLIT_HAS_X11)

=== spec/arb_draw_instanced/CMakeLists.txt ===
add_subdirectory (execution)

=== spec/arb_gpu_shader5/CMakeLists.txt ===
add_subdirectory (compiler)
add_subdirectory (execution)
add_subdirectory (linker)
piglit_include_target_api()

=== spec/arb_gpu_shader_fp64/CMakeLists.txt ===
add_subdirectory (execution)
add_subdirectory (shader_storage)
piglit_include_target_api()

=== spec/glsl-1.30/CMakeLists.txt ===
add_subdirectory (linker)
add_subdirectory (execution)
piglit_include_target_api()

=== spec/arb_geometry_shader4/execution/CMakeLists.txt ===
add_subdirectory (program-parameter)
piglit_include_target_api()

## piglit 0~git20200212-f4710c51b

=== debian/changelog ===
piglit (0~git20200212-f4710c51b-1) unstable; urgency=medium

  * Update piglit upstream version to f4710c51b (Closes: #933275,
    #948284)
  * d/gbp.conf: Fix gbp config file duplicate entry
  * d/control: Recommend waffle-utils (Closes: #943799)
  * d/control: Depend on bash-completion (Closes: #943802)
  * d/rules: Remove gcc-7 workaround (Closes: #922498)
  * d/changelog: Note that #933275 was fixed by piglit upgrade
  * d/changelog: Note that #948284 was fixed by piglit upgrade
  * d/control: Update Standards-Version to 4.4.1
  * debian: Update to debhelper-compat 12
  * d/copyright: Remove two deleted files
  * d/control: Update Standards-Version to 4.5.0
  * d/rules: Fix lintian package-contains-empty-directory
  * d/patches: Fix bash completion install and lintian warning

 -- Jordan Justen <jordan.l.justen@intel.com>  Fri, 21 Feb 2020 21:20:04 -0800

=== debian/control ===
Source: piglit
Priority: optional
Section: devel
Maintainer: Jordan Justen <jordan.l.justen@intel.com>
Build-Depends: bash-completion,
               binutils (>> 2.18),
               cmake,
               debhelper-compat (= 12),
               dh-python,
               libegl1-mesa-dev | libegl-dev,
               libgbm-dev,
               libgl1-mesa-dev | libgl-dev,
               libglu1-mesa-dev | libglu-dev,
               libxcb1-dev,
               libxkbcommon-dev,
               ocl-icd-opencl-dev | opencl-dev,
               libwaffle-dev (>= 1.3),
               pkg-config,
               python3,
               python3-mako,
               python3-numpy,
               python3-six
Standards-Version: 4.5.0
Homepage: http://piglit.freedesktop.org/
Vcs-Git: https://salsa.debian.org/xorg-team/app/piglit.git
Vcs-Browser: https://salsa.debian.org/xorg-team/app/piglit

Package: piglit
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         ${python3:Depends}, python3-six, python3-mako
Recommends: waffle-utils
Description: Open-source test suite for OpenGL and OpenCL implementations
 Piglit is an open-source test suite for OpenGL and OpenCL implementations.

=== debian/rules ===
#!/usr/bin/make -f
# Copyright (c) 2014 Intel Corporation

DEB_DESTDIR := $(CURDIR)/debian/piglit

%:
	dh $@ --buildsystem cmake --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
		-DCMAKE_BUILD_TYPE=Release \
		-DPIGLIT_BUILD_GLES1_TESTS=1 \
		-DPIGLIT_BUILD_GLES2_TESTS=1 \
		-DPIGLIT_BUILD_GLES3_TESTS=1 \
		-DPIGLIT_BUILD_CL_TESTS=1 \
		-DPIGLIT_USE_WAFFLE=1

override_dh_auto_install:
	dh_auto_install
	find $(DEB_DESTDIR) -type d -name __pycache__ -exec rm -r {} +
	find $(DEB_DESTDIR) -type d -empty -delete
	python3 $(CURDIR)/debian/update-piglit-script.py $(DEB_DESTDIR)/usr/bin/piglit

override_dh_makeshlibs:
#       Fix lintian extra-license-file
	rm $(DEB_DESTDIR)/usr/share/doc/piglit/COPYING.gz
